#
# perl/cve.pl
#
# by Sam, WWDSI 2/28/00
# SAINT support for Common Vulnerability Exposure

$cve_files = "rules/cve";

sub build_infer_cve {
    local($files) = @_;
    local($code, $cond, $number);

    $code = "sub infer_cve {\n";
    $code .= "\tlocal(\$cve);\n";
    $code .= "\t\$cve = \"\";\n";

    foreach $file (split(/\s+/, $files)) {
	open(RULES, $file) || die "cannot open $file: $!";
	while (<RULES>) {
	    chop;
	    while (/\\$/) {
		chop;
		$_ .= <RULES>;
		chop;
	    }
	    s/#.*$//;
	    s/\s+$//;
	    next if /^$/;
	    s/@/\\@/g;
	    ($cond, $number) = split(/\t+/, $_, 2);
	    die "missing cve number" if $number eq "";
	    $code .= "\
	if (\$text =~ $cond) {
		\$cve = \"$number\";
	}
";
	}
	close(RULES);
    }
    $code .= "\treturn(\$cve);\n";
    $code .= "}\n";
    return $code;
}

if ($running_under_saint) {
    eval &build_infer_cve($cve_files);
    die "error in $cve_files: $@" if $@;
}

1;
